Index: /trunk/src/VBox/Frontends/VirtualBox4/include/VBoxVMSettingsNetwork.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox4/include/VBoxVMSettingsNetwork.h	(revision 10695)
+++ /trunk/src/VBox/Frontends/VirtualBox4/include/VBoxVMSettingsNetwork.h	(revision 10696)
@@ -80,4 +80,7 @@
     void prepareComboboxes();
 
+    void setTapEnabled (bool aEnabled);
+    void setTapVisible (bool aVisible);
+
     CNetworkAdapter mAdapter;
     QIWidgetValidator *mValidator;
@@ -93,5 +96,5 @@
  * QGroupBox sub-class which represents network interface list.
  */
-class VBoxNIList : public QIWithRetranslateUI<QGroupBox>
+class VBoxNIList : public QIWithRetranslateUI<QWidget>
 {
     Q_OBJECT;
@@ -123,5 +126,6 @@
     void populateInterfacesList();
 
-    QTreeWidget *mList;
+    QILabelSeparator *mLbTitle;
+    QTreeWidget      *mList;
 
     QAction *mAddAction;
@@ -180,4 +184,6 @@
 };
 
+#undef Q_WS_WIN
+
 #endif // __VBoxVMSettingsNetwork_h__
 
Index: /trunk/src/VBox/Frontends/VirtualBox4/src/VBoxVMSettingsNetwork.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox4/src/VBoxVMSettingsNetwork.cpp	(revision 10695)
+++ /trunk/src/VBox/Frontends/VirtualBox4/src/VBoxVMSettingsNetwork.cpp	(revision 10696)
@@ -65,9 +65,9 @@
     /* Setup dialog for current platform */
 #ifndef Q_WS_X11
-    mGbTAP->setHidden (true);
+    setTapVisible (false);
 #endif
 #ifdef Q_WS_MAC
     /* No Host Interface Networking on the Mac yet */
-    mGbTAP->setHidden (true);
+    setTapVisible (false);
 #endif
 #ifdef Q_WS_X11
@@ -78,4 +78,6 @@
                                                     ":/select_file_dis_16px.png"));
 #endif
+
+    layout()->activate();
 
     /* Applying language settings */
@@ -266,5 +268,5 @@
     bool enableHostIf = vboxGlobal().toNetworkAttachmentType (aString) ==
                         KNetworkAttachmentType_HostInterface;
-    mGbTAP->setEnabled (enableHostIf);
+    setTapEnabled (enableHostIf);
 #endif
     if (mValidator)
@@ -307,11 +309,19 @@
     mCbAType->insertItem (0,
         vboxGlobal().toString (KNetworkAdapterType_Am79C970A));
+    mCbAType->setItemData (0,
+        mCbAType->itemText(0), Qt::ToolTipRole);
     mCbAType->insertItem (1,
         vboxGlobal().toString (KNetworkAdapterType_Am79C973));
+    mCbAType->setItemData (1,
+        mCbAType->itemText(1), Qt::ToolTipRole);
 #ifdef VBOX_WITH_E1000
     mCbAType->insertItem (2,
         vboxGlobal().toString (KNetworkAdapterType_I82540EM));
+    mCbAType->setItemData (2,
+        mCbAType->itemText(2), Qt::ToolTipRole);
     mCbAType->insertItem (3,
         vboxGlobal().toString (KNetworkAdapterType_I82543GC));
+    mCbAType->setItemData (3,
+        mCbAType->itemText(3), Qt::ToolTipRole);
 #endif
     /* Set the old value */
@@ -325,11 +335,19 @@
     mCbNAType->insertItem (0,
         vboxGlobal().toString (KNetworkAttachmentType_Null));
+    mCbNAType->setItemData (0,
+        mCbNAType->itemText(0), Qt::ToolTipRole);
     mCbNAType->insertItem (1,
         vboxGlobal().toString (KNetworkAttachmentType_NAT));
+    mCbNAType->setItemData (1,
+        mCbNAType->itemText(1), Qt::ToolTipRole);
 #ifndef Q_WS_MAC /* Not yet on the Mac */
     mCbNAType->insertItem (2,
         vboxGlobal().toString (KNetworkAttachmentType_HostInterface));
+    mCbNAType->setItemData (2,
+        mCbNAType->itemText(2), Qt::ToolTipRole);
     mCbNAType->insertItem (3,
         vboxGlobal().toString (KNetworkAttachmentType_Internal));
+    mCbNAType->setItemData (3,
+        mCbNAType->itemText(3), Qt::ToolTipRole);
 #endif
     /* Set the old value */
@@ -337,4 +355,29 @@
 }
 
+void VBoxVMSettingsNetwork::setTapEnabled (bool aEnabled)
+{
+    mGbTap->setEnabled (aEnabled);
+    mLbInterface_x11->setEnabled (aEnabled);
+    mLeInterface_x11->setEnabled (aEnabled);
+    mLbSetup_x11->setEnabled (aEnabled);
+    mLeSetup_x11->setEnabled (aEnabled);
+    mTbSetup_x11->setEnabled (aEnabled);
+    mLbTerminate_x11->setEnabled (aEnabled);
+    mLeTerminate_x11->setEnabled (aEnabled);
+    mTbTerminate_x11->setEnabled (aEnabled);
+}
+
+void VBoxVMSettingsNetwork::setTapVisible (bool aVisible)
+{
+    mGbTap->setVisible (aVisible);
+    mLbInterface_x11->setVisible (aVisible);
+    mLeInterface_x11->setVisible (aVisible);
+    mLbSetup_x11->setVisible (aVisible);
+    mLeSetup_x11->setVisible (aVisible);
+    mTbSetup_x11->setVisible (aVisible);
+    mLbTerminate_x11->setVisible (aVisible);
+    mLeTerminate_x11->setVisible (aVisible);
+    mTbTerminate_x11->setVisible (aVisible);
+}
 
 /* VBoxNIList Stuff */
@@ -379,10 +422,17 @@
 
 VBoxNIList::VBoxNIList (QWidget *aParent)
-    : QIWithRetranslateUI<QGroupBox> (aParent)
-{
+    : QIWithRetranslateUI<QWidget> (aParent)
+{
+    QGridLayout *mainLayout = new QGridLayout (this);
+    VBoxGlobal::setLayoutMargin (mainLayout, 0);
+    mLbTitle = new QILabelSeparator();
+    mainLayout->addWidget (mLbTitle, 0, 0, 1, 2);
+//    mainLayout->addItem (new QSpacerItem (8, 16, QSizePolicy::Fixed, QSizePolicy::Minimum), 1, 0);
     /* Creating List Widget */
-    QHBoxLayout *layout = new QHBoxLayout (this);
+    QHBoxLayout *layout = new QHBoxLayout ();
+    mainLayout->addLayout (layout, 1, 0);
     mList = new QTreeWidget (this);
     setFocusProxy (mList);
+    mLbTitle->setBuddy (mList);
     mList->setColumnCount (1);
     mList->header()->hide();
@@ -574,5 +624,5 @@
 void VBoxNIList::retranslateUi()
 {
-    setTitle (tr ("Host &Interfaces"));
+    mLbTitle->setText (tr ("Host &Interfaces"));
 
     mList->setWhatsThis (tr ("Lists all available host interfaces."));
@@ -635,6 +685,7 @@
     layout->addWidget (mNIList);
 #else
-    layout->addStretch();
-#endif
+//    layout->addItem (new QSpacerItem (0, 0, QSizePolicy::Minimum, QSizePolicy::Expanding));
+#endif
+//    layout->activate();
 }
 
@@ -672,4 +723,6 @@
         connect (page->mCbNetwork, SIGNAL (editTextChanged (const QString&)),
                  this, SLOT (updateNetworksList()));
+        page->layout()->activate();
+        page->updateGeometry();
     }
 
Index: /trunk/src/VBox/Frontends/VirtualBox4/ui/VBoxVMSettingsNetwork.ui
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox4/ui/VBoxVMSettingsNetwork.ui	(revision 10695)
+++ /trunk/src/VBox/Frontends/VirtualBox4/ui/VBoxVMSettingsNetwork.ui	(revision 10696)
@@ -23,37 +23,60 @@
     <x>0</x>
     <y>0</y>
-    <width>318</width>
-    <height>403</height>
+    <width>417</width>
+    <height>348</height>
    </rect>
   </property>
-  <layout class="QVBoxLayout" >
-   <item>
-    <widget class="QGroupBox" name="mGbAdapter" >
-     <property name="sizePolicy" >
-      <sizepolicy vsizetype="Minimum" hsizetype="Preferred" >
-       <horstretch>0</horstretch>
-       <verstretch>0</verstretch>
-      </sizepolicy>
-     </property>
+  <layout class="QGridLayout" >
+   <item row="0" column="0" colspan="2" >
+    <widget class="QCheckBox" name="mGbAdapter" >
      <property name="whatsThis" >
       <string>When checked, plugs this virtual network adapter into the virtual machine.</string>
      </property>
-     <property name="title" >
+     <property name="text" >
       <string>&amp;Enable Network Adapter</string>
-     </property>
-     <property name="checkable" >
-      <bool>true</bool>
      </property>
      <property name="checked" >
       <bool>true</bool>
      </property>
+    </widget>
+   </item>
+   <item row="1" column="0" >
+    <spacer>
+     <property name="orientation" >
+      <enum>Qt::Horizontal</enum>
+     </property>
+     <property name="sizeType" >
+      <enum>QSizePolicy::Fixed</enum>
+     </property>
+     <property name="sizeHint" >
+      <size>
+       <width>20</width>
+       <height>20</height>
+      </size>
+     </property>
+    </spacer>
+   </item>
+   <item row="1" column="1" >
+    <widget class="QWidget" native="1" name="mNetworkChild" >
      <layout class="QGridLayout" >
+      <property name="leftMargin" >
+       <number>0</number>
+      </property>
       <property name="topMargin" >
-       <number>5</number>
+       <number>0</number>
+      </property>
+      <property name="rightMargin" >
+       <number>0</number>
+      </property>
+      <property name="bottomMargin" >
+       <number>0</number>
       </property>
       <item row="0" column="0" >
        <widget class="QLabel" name="mLbAType" >
         <property name="text" >
-         <string>A&amp;dapter Type</string>
+         <string>A&amp;dapter Type:</string>
+        </property>
+        <property name="alignment" >
+         <set>Qt::AlignRight|Qt::AlignTrailing|Qt::AlignVCenter</set>
         </property>
         <property name="buddy" >
@@ -62,5 +85,5 @@
        </widget>
       </item>
-      <item row="0" column="1" colspan="2" >
+      <item row="0" column="1" >
        <widget class="QComboBox" name="mCbAType" >
         <property name="whatsThis" >
@@ -72,5 +95,8 @@
        <widget class="QLabel" name="mLbNAType" >
         <property name="text" >
-         <string>&amp;Attached to</string>
+         <string>&amp;Attached to:</string>
+        </property>
+        <property name="alignment" >
+         <set>Qt::AlignRight|Qt::AlignTrailing|Qt::AlignVCenter</set>
         </property>
         <property name="buddy" >
@@ -79,5 +105,5 @@
        </widget>
       </item>
-      <item row="1" column="1" colspan="2" >
+      <item row="1" column="1" >
        <widget class="QComboBox" name="mCbNAType" >
         <property name="whatsThis" >
@@ -89,5 +115,8 @@
        <widget class="QLabel" name="mLbNetwork" >
         <property name="text" >
-         <string>&amp;Network Name</string>
+         <string>&amp;Network Name:</string>
+        </property>
+        <property name="alignment" >
+         <set>Qt::AlignRight|Qt::AlignTrailing|Qt::AlignVCenter</set>
         </property>
         <property name="buddy" >
@@ -96,5 +125,5 @@
        </widget>
       </item>
-      <item row="2" column="1" colspan="2" >
+      <item row="2" column="1" >
        <widget class="QComboBox" name="mCbNetwork" >
         <property name="whatsThis" >
@@ -109,5 +138,8 @@
        <widget class="QLabel" name="mLbMAC" >
         <property name="text" >
-         <string>&amp;MAC Address</string>
+         <string>&amp;MAC Address:</string>
+        </property>
+        <property name="alignment" >
+         <set>Qt::AlignRight|Qt::AlignTrailing|Qt::AlignVCenter</set>
         </property>
         <property name="buddy" >
@@ -118,4 +150,10 @@
       <item row="3" column="1" >
        <widget class="QLineEdit" name="mLeMAC" >
+        <property name="sizePolicy" >
+         <sizepolicy vsizetype="Fixed" hsizetype="Preferred" >
+          <horstretch>0</horstretch>
+          <verstretch>0</verstretch>
+         </sizepolicy>
+        </property>
         <property name="whatsThis" >
          <string>Displays the MAC address of this adapter. It contains exactly 12 characters chosen from {0-9,A-F}. Note that the second character must be an even digit.</string>
@@ -136,5 +174,5 @@
        </widget>
       </item>
-      <item row="4" column="0" colspan="3" >
+      <item row="4" column="1" >
        <widget class="QCheckBox" name="mCbCable" >
         <property name="whatsThis" >
@@ -143,4 +181,112 @@
         <property name="text" >
          <string>Ca&amp;ble Connected</string>
+        </property>
+       </widget>
+      </item>
+      <item row="5" column="0" colspan="3" >
+       <widget class="QILabelSeparator" name="mGbTap" >
+        <property name="text" >
+         <string>&amp;Host Interface Settings</string>
+        </property>
+        <property name="buddy" >
+         <cstring>mLeInterface_x11</cstring>
+        </property>
+       </widget>
+      </item>
+      <item row="6" column="0" >
+       <widget class="QLabel" name="mLbInterface_x11" >
+        <property name="text" >
+         <string>&amp;Interface Name:</string>
+        </property>
+        <property name="alignment" >
+         <set>Qt::AlignRight|Qt::AlignTrailing|Qt::AlignVCenter</set>
+        </property>
+        <property name="buddy" >
+         <cstring>mLeInterface_x11</cstring>
+        </property>
+       </widget>
+      </item>
+      <item row="6" column="1" >
+       <widget class="QLineEdit" name="mLeInterface_x11" >
+        <property name="sizePolicy" >
+         <sizepolicy vsizetype="Fixed" hsizetype="Preferred" >
+          <horstretch>0</horstretch>
+          <verstretch>0</verstretch>
+         </sizepolicy>
+        </property>
+        <property name="whatsThis" >
+         <string>Displays the TAP interface name.</string>
+        </property>
+       </widget>
+      </item>
+      <item row="7" column="0" >
+       <widget class="QLabel" name="mLbSetup_x11" >
+        <property name="text" >
+         <string>&amp;Setup Application:</string>
+        </property>
+        <property name="alignment" >
+         <set>Qt::AlignRight|Qt::AlignTrailing|Qt::AlignVCenter</set>
+        </property>
+        <property name="buddy" >
+         <cstring>mLeSetup_x11</cstring>
+        </property>
+       </widget>
+      </item>
+      <item row="7" column="1" >
+       <widget class="QLineEdit" name="mLeSetup_x11" >
+        <property name="sizePolicy" >
+         <sizepolicy vsizetype="Fixed" hsizetype="Preferred" >
+          <horstretch>0</horstretch>
+          <verstretch>0</verstretch>
+         </sizepolicy>
+        </property>
+        <property name="whatsThis" >
+         <string>Displays the command executed to set up the TAP interface.</string>
+        </property>
+       </widget>
+      </item>
+      <item row="7" column="2" >
+       <widget class="QToolButton" name="mTbSetup_x11" >
+        <property name="whatsThis" >
+         <string>Selects the setup application.</string>
+        </property>
+        <property name="autoRaise" >
+         <bool>true</bool>
+        </property>
+       </widget>
+      </item>
+      <item row="8" column="0" >
+       <widget class="QLabel" name="mLbTerminate_x11" >
+        <property name="text" >
+         <string>&amp;Terminate Application:</string>
+        </property>
+        <property name="alignment" >
+         <set>Qt::AlignRight|Qt::AlignTrailing|Qt::AlignVCenter</set>
+        </property>
+        <property name="buddy" >
+         <cstring>mLeTerminate_x11</cstring>
+        </property>
+       </widget>
+      </item>
+      <item row="8" column="1" >
+       <widget class="QLineEdit" name="mLeTerminate_x11" >
+        <property name="sizePolicy" >
+         <sizepolicy vsizetype="Fixed" hsizetype="Preferred" >
+          <horstretch>0</horstretch>
+          <verstretch>0</verstretch>
+         </sizepolicy>
+        </property>
+        <property name="whatsThis" >
+         <string>Displays the command executed to terminate the TAP interface.</string>
+        </property>
+       </widget>
+      </item>
+      <item row="8" column="2" >
+       <widget class="QToolButton" name="mTbTerminate_x11" >
+        <property name="whatsThis" >
+         <string>Selects the terminate application.</string>
+        </property>
+        <property name="autoRaise" >
+         <bool>true</bool>
         </property>
        </widget>
@@ -149,134 +295,57 @@
     </widget>
    </item>
-   <item>
-    <widget class="QGroupBox" name="mGbTAP" >
-     <property name="sizePolicy" >
-      <sizepolicy vsizetype="Expanding" hsizetype="Preferred" >
-       <horstretch>0</horstretch>
-       <verstretch>0</verstretch>
-      </sizepolicy>
-     </property>
-     <property name="whatsThis" >
-      <string>Host Interface Settings</string>
-     </property>
-     <property name="title" >
-      <string>Host Interface Settings</string>
-     </property>
-     <layout class="QVBoxLayout" >
-      <property name="topMargin" >
-       <number>5</number>
-      </property>
-      <item>
-       <layout class="QVBoxLayout" >
-        <property name="spacing" >
-         <number>0</number>
-        </property>
-        <item>
-         <widget class="QLabel" name="mLbInterface_x11" >
-          <property name="text" >
-           <string>&amp;Interface Name</string>
-          </property>
-          <property name="buddy" >
-           <cstring>mLeInterface_x11</cstring>
-          </property>
-         </widget>
-        </item>
-        <item>
-         <widget class="QLineEdit" name="mLeInterface_x11" >
-          <property name="whatsThis" >
-           <string>Displays the TAP interface name.</string>
-          </property>
-         </widget>
-        </item>
-       </layout>
-      </item>
-      <item>
-       <layout class="QVBoxLayout" >
-        <property name="spacing" >
-         <number>0</number>
-        </property>
-        <item>
-         <widget class="QLabel" name="mLbSetup_x11" >
-          <property name="text" >
-           <string>&amp;Setup Application</string>
-          </property>
-          <property name="buddy" >
-           <cstring>mLeSetup_x11</cstring>
-          </property>
-         </widget>
-        </item>
-        <item>
-         <layout class="QHBoxLayout" >
-          <property name="spacing" >
-           <number>6</number>
-          </property>
-          <item>
-           <widget class="QLineEdit" name="mLeSetup_x11" >
-            <property name="whatsThis" >
-             <string>Displays the command executed to set up the TAP interface.</string>
-            </property>
-           </widget>
-          </item>
-          <item>
-           <widget class="QToolButton" name="mTbSetup_x11" >
-            <property name="whatsThis" >
-             <string>Selects the setup application.</string>
-            </property>
-            <property name="autoRaise" >
-             <bool>true</bool>
-            </property>
-           </widget>
-          </item>
-         </layout>
-        </item>
-       </layout>
-      </item>
-      <item>
-       <layout class="QVBoxLayout" >
-        <property name="spacing" >
-         <number>0</number>
-        </property>
-        <item>
-         <widget class="QLabel" name="mLbTerminate_x11" >
-          <property name="text" >
-           <string>&amp;Terminate Application</string>
-          </property>
-          <property name="buddy" >
-           <cstring>mLeTerminate_x11</cstring>
-          </property>
-         </widget>
-        </item>
-        <item>
-         <layout class="QHBoxLayout" >
-          <property name="spacing" >
-           <number>6</number>
-          </property>
-          <item>
-           <widget class="QLineEdit" name="mLeTerminate_x11" >
-            <property name="whatsThis" >
-             <string>Displays the command executed to terminate the TAP interface.</string>
-            </property>
-           </widget>
-          </item>
-          <item>
-           <widget class="QToolButton" name="mTbTerminate_x11" >
-            <property name="whatsThis" >
-             <string>Selects the terminate application.</string>
-            </property>
-            <property name="autoRaise" >
-             <bool>true</bool>
-            </property>
-           </widget>
-          </item>
-         </layout>
-        </item>
-       </layout>
-      </item>
-     </layout>
-    </widget>
+   <item row="1" column="2" >
+    <spacer>
+     <property name="orientation" >
+      <enum>Qt::Horizontal</enum>
+     </property>
+     <property name="sizeHint" >
+      <size>
+       <width>40</width>
+       <height>20</height>
+      </size>
+     </property>
+    </spacer>
+   </item>
+   <item row="2" column="1" >
+    <spacer>
+     <property name="orientation" >
+      <enum>Qt::Vertical</enum>
+     </property>
+     <property name="sizeHint" >
+      <size>
+       <width>20</width>
+       <height>40</height>
+      </size>
+     </property>
+    </spacer>
    </item>
   </layout>
  </widget>
+ <customwidgets>
+  <customwidget>
+   <class>QILabelSeparator</class>
+   <extends>QLabel</extends>
+   <header>QILabelSeparator.h</header>
+  </customwidget>
+ </customwidgets>
  <resources/>
- <connections/>
+ <connections>
+  <connection>
+   <sender>mGbAdapter</sender>
+   <signal>toggled(bool)</signal>
+   <receiver>mNetworkChild</receiver>
+   <slot>setEnabled(bool)</slot>
+   <hints>
+    <hint type="sourcelabel" >
+     <x>190</x>
+     <y>19</y>
+    </hint>
+    <hint type="destinationlabel" >
+     <x>203</x>
+     <y>164</y>
+    </hint>
+   </hints>
+  </connection>
+ </connections>
 </ui>