Index: /trunk/src/VBox/Frontends/VirtualBox4/src/VBoxVMSettingsParallel.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox4/src/VBoxVMSettingsParallel.cpp	(revision 10699)
+++ /trunk/src/VBox/Frontends/VirtualBox4/src/VBoxVMSettingsParallel.cpp	(revision 10700)
@@ -41,8 +41,6 @@
 
     /* Setup constraints */
-    mLeIRQ->setMaximumWidth (mLeIRQ->fontMetrics().width ("888888"));
-    mLeIRQ->setMinimumWidth (mLeIRQ->minimumWidth());
-    mLeIOPort->setMaximumWidth (mLeIOPort->fontMetrics().width ("8888888"));
-    mLeIOPort->setMinimumWidth (mLeIOPort->minimumWidth());
+    mLeIRQ->setFixedWidth (mLeIRQ->fontMetrics().width ("8888"));
+    mLeIOPort->setFixedWidth (mLeIOPort->fontMetrics().width ("8888888"));
 
     /* Set initial values */
@@ -161,10 +159,7 @@
     /* TabWidget creation */
     mTabWidget = new QTabWidget (this);
-    mTabWidget->setSizePolicy (QSizePolicy::Expanding,
-                               QSizePolicy::Fixed);
     QVBoxLayout *layout = new QVBoxLayout (this);
     layout->setContentsMargins (0, 5, 0, 5);
     layout->addWidget (mTabWidget);
-    layout->addStretch();
 }
 
Index: /trunk/src/VBox/Frontends/VirtualBox4/ui/VBoxVMSettingsParallel.ui
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox4/ui/VBoxVMSettingsParallel.ui	(revision 10699)
+++ /trunk/src/VBox/Frontends/VirtualBox4/ui/VBoxVMSettingsParallel.ui	(revision 10700)
@@ -23,28 +23,60 @@
     <x>0</x>
     <y>0</y>
-    <width>378</width>
-    <height>163</height>
+    <width>348</width>
+    <height>122</height>
    </rect>
   </property>
-  <layout class="QVBoxLayout" >
-   <item>
-    <widget class="QGroupBox" name="mGbParallel" >
+  <layout class="QGridLayout" >
+   <item row="0" column="0" colspan="2" >
+    <widget class="QCheckBox" name="mGbParallel" >
      <property name="whatsThis" >
       <string>When checked, enables the given parallel port of the virtual machine.</string>
      </property>
-     <property name="title" >
+     <property name="text" >
       <string>&amp;Enable Parallel Port</string>
      </property>
-     <property name="checkable" >
+     <property name="checked" >
       <bool>true</bool>
      </property>
+    </widget>
+   </item>
+   <item row="1" column="0" >
+    <spacer>
+     <property name="orientation" >
+      <enum>Qt::Horizontal</enum>
+     </property>
+     <property name="sizeType" >
+      <enum>QSizePolicy::Fixed</enum>
+     </property>
+     <property name="sizeHint" >
+      <size>
+       <width>20</width>
+       <height>20</height>
+      </size>
+     </property>
+    </spacer>
+   </item>
+   <item row="1" column="1" >
+    <widget class="QWidget" native="1" name="mParallelChild" >
      <layout class="QGridLayout" >
+      <property name="leftMargin" >
+       <number>0</number>
+      </property>
       <property name="topMargin" >
-       <number>5</number>
+       <number>0</number>
+      </property>
+      <property name="rightMargin" >
+       <number>0</number>
+      </property>
+      <property name="bottomMargin" >
+       <number>0</number>
       </property>
       <item row="0" column="0" >
        <widget class="QLabel" name="mLbNumber" >
         <property name="text" >
-         <string>Port &amp;Number</string>
+         <string>Port &amp;Number:</string>
+        </property>
+        <property name="alignment" >
+         <set>Qt::AlignRight|Qt::AlignTrailing|Qt::AlignVCenter</set>
         </property>
         <property name="buddy" >
@@ -61,74 +93,56 @@
       </item>
       <item row="0" column="2" >
-       <layout class="QHBoxLayout" >
-        <item>
-         <widget class="QLabel" name="mLbIRQ" >
-          <property name="text" >
-           <string>&amp;IRQ</string>
-          </property>
-          <property name="buddy" >
-           <cstring>mLeIRQ</cstring>
-          </property>
-         </widget>
-        </item>
-        <item>
-         <widget class="QLineEdit" name="mLeIRQ" >
-          <property name="sizePolicy" >
-           <sizepolicy vsizetype="Fixed" hsizetype="Preferred" >
-            <horstretch>0</horstretch>
-            <verstretch>0</verstretch>
-           </sizepolicy>
-          </property>
-          <property name="whatsThis" >
-           <string>Displays the IRQ number of this parallel port. Valid values are integer numbers in range from &lt;tt>0&lt;/tt> to &lt;tt>255&lt;/tt>. Values greater than &lt;tt>15&lt;/tt> may be used only if the &lt;b>IO APIC&lt;/b> is enabled for this virtual machine.</string>
-          </property>
-         </widget>
-        </item>
-       </layout>
+       <widget class="QLabel" name="mLbIRQ" >
+        <property name="text" >
+         <string>&amp;IRQ:</string>
+        </property>
+        <property name="buddy" >
+         <cstring>mLeIRQ</cstring>
+        </property>
+       </widget>
       </item>
       <item row="0" column="3" >
-       <layout class="QHBoxLayout" >
-        <item>
-         <widget class="QLabel" name="mLbIOPort" >
-          <property name="text" >
-           <string>I/O Po&amp;rt</string>
-          </property>
-          <property name="buddy" >
-           <cstring>mLbIOPort</cstring>
-          </property>
-         </widget>
-        </item>
-        <item>
-         <widget class="QLineEdit" name="mLeIOPort" >
-          <property name="sizePolicy" >
-           <sizepolicy vsizetype="Fixed" hsizetype="Preferred" >
-            <horstretch>0</horstretch>
-            <verstretch>0</verstretch>
-           </sizepolicy>
-          </property>
-          <property name="whatsThis" >
-           <string>Displays the base I/O port address of this parallel port. Valid values are integer numbers in range from &lt;tt>0&lt;/tt> to &lt;tt>0xFFFF&lt;/tt>.</string>
-          </property>
-         </widget>
-        </item>
-       </layout>
+       <widget class="QLineEdit" name="mLeIRQ" >
+        <property name="sizePolicy" >
+         <sizepolicy vsizetype="Fixed" hsizetype="Preferred" >
+          <horstretch>0</horstretch>
+          <verstretch>0</verstretch>
+         </sizepolicy>
+        </property>
+        <property name="whatsThis" >
+         <string>Displays the IRQ number of this parallel port. Valid values are integer numbers in range from &lt;tt>0&lt;/tt> to &lt;tt>255&lt;/tt>. Values greater than &lt;tt>15&lt;/tt> may be used only if the &lt;b>IO APIC&lt;/b> is enabled for this virtual machine.</string>
+        </property>
+       </widget>
       </item>
       <item row="0" column="4" >
-       <spacer>
-        <property name="orientation" >
-         <enum>Qt::Horizontal</enum>
-        </property>
-        <property name="sizeHint" >
-         <size>
-          <width>0</width>
-          <height>20</height>
-         </size>
-        </property>
-       </spacer>
-      </item>
-      <item rowspan="2" row="1" column="0" >
+       <widget class="QLabel" name="mLbIOPort" >
+        <property name="text" >
+         <string>I/O Po&amp;rt:</string>
+        </property>
+        <property name="buddy" >
+         <cstring>mLbIOPort</cstring>
+        </property>
+       </widget>
+      </item>
+      <item row="0" column="5" >
+       <widget class="QLineEdit" name="mLeIOPort" >
+        <property name="sizePolicy" >
+         <sizepolicy vsizetype="Fixed" hsizetype="Preferred" >
+          <horstretch>0</horstretch>
+          <verstretch>0</verstretch>
+         </sizepolicy>
+        </property>
+        <property name="whatsThis" >
+         <string>Displays the base I/O port address of this parallel port. Valid values are integer numbers in range from &lt;tt>0&lt;/tt> to &lt;tt>0xFFFF&lt;/tt>.</string>
+        </property>
+       </widget>
+      </item>
+      <item row="1" column="0" >
        <widget class="QLabel" name="mLbPath" >
         <property name="text" >
-         <string>Port &amp;Path</string>
+         <string>Port &amp;Path:</string>
+        </property>
+        <property name="alignment" >
+         <set>Qt::AlignRight|Qt::AlignTrailing|Qt::AlignVCenter</set>
         </property>
         <property name="buddy" >
@@ -137,5 +151,5 @@
        </widget>
       </item>
-      <item rowspan="2" row="1" column="1" colspan="4" >
+      <item row="1" column="1" colspan="5" >
        <widget class="QLineEdit" name="mLePath" >
         <property name="whatsThis" >
@@ -143,24 +157,54 @@
         </property>
        </widget>
-      </item>
-      <item row="3" column="2" >
-       <spacer>
-        <property name="orientation" >
-         <enum>Qt::Vertical</enum>
-        </property>
-        <property name="sizeHint" >
-         <size>
-          <width>20</width>
-          <height>0</height>
-         </size>
-        </property>
-       </spacer>
       </item>
      </layout>
     </widget>
+   </item>
+   <item row="1" column="2" >
+    <spacer>
+     <property name="orientation" >
+      <enum>Qt::Horizontal</enum>
+     </property>
+     <property name="sizeHint" >
+      <size>
+       <width>40</width>
+       <height>20</height>
+      </size>
+     </property>
+    </spacer>
+   </item>
+   <item row="2" column="1" >
+    <spacer>
+     <property name="orientation" >
+      <enum>Qt::Vertical</enum>
+     </property>
+     <property name="sizeHint" >
+      <size>
+       <width>16</width>
+       <height>21</height>
+      </size>
+     </property>
+    </spacer>
    </item>
   </layout>
  </widget>
  <resources/>
- <connections/>
+ <connections>
+  <connection>
+   <sender>mGbParallel</sender>
+   <signal>toggled(bool)</signal>
+   <receiver>mParallelChild</receiver>
+   <slot>setEnabled(bool)</slot>
+   <hints>
+    <hint type="sourcelabel" >
+     <x>76</x>
+     <y>20</y>
+    </hint>
+    <hint type="destinationlabel" >
+     <x>285</x>
+     <y>120</y>
+    </hint>
+   </hints>
+  </connection>
+ </connections>
 </ui>