Index: /trunk/src/VBox/Frontends/VirtualBox4/src/VBoxGLSettingsUpdate.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox4/src/VBoxGLSettingsUpdate.cpp	(revision 10855)
+++ /trunk/src/VBox/Frontends/VirtualBox4/src/VBoxGLSettingsUpdate.cpp	(revision 10856)
@@ -94,4 +94,6 @@
     mLbOncePer->setEnabled (aOn);
     mCbOncePer->setEnabled (aOn);
+    mLbDate->setEnabled (aOn);
+    mTxDate->setEnabled (aOn);
 
     /* Update 'check for new version' time */
Index: /trunk/src/VBox/Frontends/VirtualBox4/src/VBoxUpdateDlg.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox4/src/VBoxUpdateDlg.cpp	(revision 10855)
+++ /trunk/src/VBox/Frontends/VirtualBox4/src/VBoxUpdateDlg.cpp	(revision 10856)
@@ -143,5 +143,5 @@
 {
     return mIndex == NeverCheck ? VBoxUpdateDlg::tr ("Never") :
-           mDate.toString ("yyyy.MM.dd");
+           mDate.toString (Qt::LocaleDate);
 }
 
Index: /trunk/src/VBox/Frontends/VirtualBox4/ui/VBoxGLSettingsUpdate.ui
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox4/ui/VBoxGLSettingsUpdate.ui	(revision 10855)
+++ /trunk/src/VBox/Frontends/VirtualBox4/ui/VBoxGLSettingsUpdate.ui	(revision 10856)
@@ -23,6 +23,6 @@
     <x>0</x>
     <y>0</y>
-    <width>310</width>
-    <height>183</height>
+    <width>300</width>
+    <height>131</height>
    </rect>
   </property>
@@ -40,6 +40,9 @@
     <number>0</number>
    </property>
-   <item row="0" column="1" >
+   <item row="0" column="1" colspan="4" >
     <widget class="QCheckBox" name="mCbCheck" >
+     <property name="whatsThis" >
+      <string>When checked, the application will periodically connect to the VirtualBox web-site and check whether a new VirtualBox verison is available.</string>
+     </property>
      <property name="text" >
       <string>&amp;Check for a New Version</string>
@@ -48,10 +51,7 @@
       <bool>true</bool>
      </property>
-     <property name="whatsThis" >
-      <string>When checked, the application will periodically connect to the VirtualBox web-site and check whether a new VirtualBox verison is available.</string>
-     </property>
     </widget>
    </item>
-   <item row="1" column="0" >
+   <item rowspan="3" row="0" column="0" >
     <spacer>
      <property name="orientation" >
@@ -64,5 +64,5 @@
       <size>
        <width>40</width>
-       <height>10</height>
+       <height>0</height>
       </size>
      </property>
@@ -70,103 +70,95 @@
    </item>
    <item row="1" column="1" >
-    <layout class="QHBoxLayout" >
-     <property name="spacing" >
-      <number>0</number>
+    <spacer>
+     <property name="orientation" >
+      <enum>Qt::Horizontal</enum>
      </property>
-     <item>
-      <spacer>
-       <property name="orientation" >
-        <enum>Qt::Horizontal</enum>
-       </property>
-       <property name="sizeType" >
-        <enum>QSizePolicy::Fixed</enum>
-       </property>
-       <property name="sizeHint" >
-        <size>
-         <width>20</width>
-         <height>10</height>
-        </size>
-       </property>
-      </spacer>
-     </item>
-     <item>
-      <widget class="QLabel" name="mLbOncePer" >
-       <property name="text" >
-        <string>&amp;Once per:</string>
-       </property>
-       <property name="buddy" >
-        <cstring>mCbOncePer</cstring>
-       </property>
-      </widget>
-     </item>
-     <item>
-      <spacer>
-       <property name="orientation" >
-        <enum>Qt::Horizontal</enum>
-       </property>
-       <property name="sizeType" >
-        <enum>QSizePolicy::Fixed</enum>
-       </property>
-       <property name="sizeHint" >
-        <size>
-         <width>16</width>
-         <height>10</height>
-        </size>
-       </property>
-      </spacer>
-     </item>
-     <item>
-      <widget class="QComboBox" name="mCbOncePer">
-       <property name="whatsThis" >
-        <string>Specifies how often the new version check should be performed. Note that if you want to completely disable this check, just clear the above check box.</string>
-       </property>
-      </widget>
-     </item>
-     <item>
-      <spacer>
-       <property name="orientation" >
-        <enum>Qt::Horizontal</enum>
-       </property>
-       <property name="sizeHint" >
-        <size>
-         <width>0</width>
-         <height>10</height>
-        </size>
-       </property>
-      </spacer>
-     </item>
-    </layout>
+     <property name="sizeType" >
+      <enum>QSizePolicy::Fixed</enum>
+     </property>
+     <property name="sizeHint" >
+      <size>
+       <width>16</width>
+       <height>0</height>
+      </size>
+     </property>
+    </spacer>
+   </item>
+   <item row="1" column="2" >
+    <widget class="QLabel" name="mLbOncePer" >
+     <property name="text" >
+      <string>&amp;Once per:</string>
+     </property>
+     <property name="alignment" >
+      <set>Qt::AlignRight|Qt::AlignTrailing|Qt::AlignVCenter</set>
+     </property>
+     <property name="buddy" >
+      <cstring>mCbOncePer</cstring>
+     </property>
+    </widget>
+   </item>
+   <item row="1" column="3" >
+    <widget class="QComboBox" name="mCbOncePer" >
+     <property name="whatsThis" >
+      <string>Specifies how often the new version check should be performed. Note that if you want to completely disable this check, just clear the above check box.</string>
+     </property>
+    </widget>
+   </item>
+   <item row="1" column="4" >
+    <spacer>
+     <property name="orientation" >
+      <enum>Qt::Horizontal</enum>
+     </property>
+     <property name="sizeHint" >
+      <size>
+       <width>0</width>
+       <height>0</height>
+      </size>
+     </property>
+    </spacer>
    </item>
    <item row="2" column="1" >
-    <layout class="QHBoxLayout" >
-     <property name="spacing" >
-      <number>10</number>
+    <spacer>
+     <property name="orientation" >
+      <enum>Qt::Horizontal</enum>
      </property>
-     <item>
-      <widget class="QLabel" name="mLbDate" >
-       <property name="sizePolicy" >
-        <sizepolicy vsizetype="Preferred" hsizetype="Preferred" >
-         <horstretch>0</horstretch>
-         <verstretch>0</verstretch>
-        </sizepolicy>
-       </property>
-       <property name="text" >
-        <string>Next Check:</string>
-       </property>
-      </widget>
-     </item>
-     <item>
-      <widget class="QLabel" name="mTxDate" >
-       <property name="sizePolicy" >
-        <sizepolicy vsizetype="Preferred" hsizetype="Expanding" >
-         <horstretch>0</horstretch>
-         <verstretch>0</verstretch>
-        </sizepolicy>
-       </property>
-      </widget>
-     </item>
-    </layout>
+     <property name="sizeType" >
+      <enum>QSizePolicy::Fixed</enum>
+     </property>
+     <property name="sizeHint" >
+      <size>
+       <width>16</width>
+       <height>0</height>
+      </size>
+     </property>
+    </spacer>
    </item>
-   <item row="3" column="1" >
+   <item row="2" column="2" >
+    <widget class="QLabel" name="mLbDate" >
+     <property name="sizePolicy" >
+      <sizepolicy vsizetype="Preferred" hsizetype="Preferred" >
+       <horstretch>0</horstretch>
+       <verstretch>0</verstretch>
+      </sizepolicy>
+     </property>
+     <property name="text" >
+      <string>Next Check:</string>
+     </property>
+     <property name="alignment" >
+      <set>Qt::AlignRight|Qt::AlignTrailing|Qt::AlignVCenter</set>
+     </property>
+    </widget>
+   </item>
+   <item row="2" column="3" colspan="2" >
+    <widget class="QLabel" name="mTxDate" >
+     <property name="sizePolicy" >
+      <sizepolicy vsizetype="Preferred" hsizetype="Expanding" >
+       <horstretch>0</horstretch>
+       <verstretch>0</verstretch>
+      </sizepolicy>
+     </property>
+    </widget>
+   </item>
+   <item row="3" column="0" colspan="5" >
     <spacer>
      <property name="orientation" >
@@ -175,5 +167,5 @@
      <property name="sizeHint" >
       <size>
-       <width>10</width>
+       <width>0</width>
        <height>0</height>
       </size>