Index: trunk/src/VBox/Frontends/VirtualBox4/include/VBoxVMSettingsNetwork.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox4/include/VBoxVMSettingsNetwork.h	(revision 10896)
+++ trunk/src/VBox/Frontends/VirtualBox4/include/VBoxVMSettingsNetwork.h	(revision 10897)
@@ -28,5 +28,5 @@
 #include "COMDefs.h"
 
-#ifdef Q_WS_WIN
+#if defined (Q_WS_WIN) || defined (Q_OS_MAC)
 class QTreeWidget;
 class QTreeWidgetItem;
@@ -57,5 +57,5 @@
     void setNetworksList (const QStringList &aList);
 
-#ifdef Q_WS_WIN
+#if defined (Q_WS_WIN) || defined (Q_OS_MAC)
     void setInterfaceName (const QString &);
     QString interfaceName() const;
@@ -86,5 +86,5 @@
     QIWidgetValidator *mValidator;
 
-#ifdef Q_WS_WIN
+#if defined (Q_WS_WIN) || defined (Q_OS_MAC)
     QString mInterfaceName;
 #endif
@@ -92,5 +92,5 @@
 
 
-#ifdef Q_WS_WIN
+#if defined (Q_WS_WIN) || defined (Q_OS_MAC) || defined(__APPLE__) /// @todo fix stupid stupid moc.
 /*
  * QGroupBox sub-class which represents network interface list.
@@ -129,8 +129,10 @@
     QTreeWidget      *mList;
 
+# if defined (Q_WS_WIN)
     QAction *mAddAction;
     QAction *mDelAction;
+# endif
 };
-#endif
+#endif /* Q_WS_WIN || Q_OS_MAC */
 
 
@@ -159,5 +161,5 @@
 
     void updateNetworksList();
-#ifdef Q_WS_WIN
+#if defined (Q_WS_WIN) || defined (Q_OS_MAC) || defined (__APPLE__) /// @todo fix stupid stupid moc.
     void onCurrentPageChanged (int);
     void onCurrentInterfaceChanged (const QString &);
@@ -170,5 +172,5 @@
     /* Widgets */
     QTabWidget *mTwAdapters;
-#ifdef Q_WS_WIN
+#if defined (Q_WS_WIN) || defined (Q_OS_MAC)
     VBoxNIList *mNIList;
 #endif
Index: trunk/src/VBox/Frontends/VirtualBox4/src/VBoxVMSettingsNetwork.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox4/src/VBoxVMSettingsNetwork.cpp	(revision 10896)
+++ trunk/src/VBox/Frontends/VirtualBox4/src/VBoxVMSettingsNetwork.cpp	(revision 10897)
@@ -25,5 +25,5 @@
 #include "QIWidgetValidator.h"
 #include "VBoxGlobal.h"
-#ifdef Q_WS_WIN
+#if defined (Q_WS_WIN) || defined (Q_OS_MAC)
 #include "VBoxToolBar.h"
 #include "VBoxSettingsUtils.h"
@@ -35,10 +35,10 @@
 #include <QFileDialog>
 #endif
-#ifdef Q_WS_WIN
+#if defined (Q_WS_WIN) || defined (Q_OS_MAC)
 #include <QTreeWidget>
 #endif
 
 /* Common Stuff */
-#ifdef Q_WS_WIN
+#if defined (Q_WS_WIN) || defined (Q_OS_MAC)
 static QTreeWidgetItem* findItem (QTreeWidget *aList,
                                   const QString &aMatch)
@@ -65,8 +65,4 @@
     /* Setup dialog for current platform */
 #ifndef Q_WS_X11
-    setTapVisible (false);
-#endif
-#ifdef Q_WS_MAC /// @todo hif on mac
-    /* No Host Interface Networking on the Mac yet */
     setTapVisible (false);
 #endif
@@ -107,5 +103,5 @@
     mCbNetwork->setCurrentIndex (inPos == -1 ? 0 : inPos);
 
-#ifdef Q_WS_WIN
+#if defined (Q_WS_WIN) || defined (Q_OS_MAC)
     mInterfaceName = aAdapter.GetHostInterface().isEmpty() ?
                      QString::null : aAdapter.GetHostInterface();
@@ -152,5 +148,5 @@
     if (type == KNetworkAttachmentType_HostInterface)
     {
-#ifdef Q_WS_WIN
+#if defined (Q_WS_WIN) || defined (Q_OS_MAC)
         mAdapter.SetHostInterface (mInterfaceName);
 #endif
@@ -226,5 +222,5 @@
 }
 
-#ifdef Q_WS_WIN
+#if defined (Q_WS_WIN) || defined (Q_OS_MAC)
 void VBoxVMSettingsNetwork::setInterfaceName (const QString &aName)
 {
@@ -380,5 +376,5 @@
 
 /* VBoxNIList Stuff */
-#ifdef Q_WS_WIN
+#if defined (Q_WS_WIN) || defined (Q_OS_MAC)
 class VBoxNIListItem : public QTreeWidgetItem
 {
@@ -440,4 +436,5 @@
 
     /* Prepare actions */
+# if defined (Q_WS_WIN)
     mAddAction = new QAction (mList);
     mDelAction = new QAction (mList);
@@ -450,4 +447,5 @@
     mDelAction->setIcon (VBoxGlobal::iconSet (":/remove_host_iface_16px.png",
                                               ":/remove_host_iface_disabled_16px.png"));
+# endif /* Q_WS_WIN */
 
     /* Prepare toolbar */
@@ -456,6 +454,8 @@
     toolBar->setUsesBigPixmaps (false);
     toolBar->setOrientation (Qt::Vertical);
+# if defined (Q_WS_WIN)
     toolBar->addAction (mAddAction);
     toolBar->addAction (mDelAction);
+# endif /* Q_WS_WIN */
     layout->addWidget (toolBar);
 
@@ -463,8 +463,10 @@
     connect (mList, SIGNAL (currentItemChanged (QTreeWidgetItem *, QTreeWidgetItem *)),
              this, SLOT (onCurrentItemChanged (QTreeWidgetItem *, QTreeWidgetItem *)));
+# if defined (Q_WS_WIN)
     connect (mAddAction, SIGNAL (triggered (bool)),
              this, SLOT (addHostInterface()));
     connect (mDelAction, SIGNAL (triggered (bool)),
              this, SLOT (delHostInterface()));
+# endif /* Q_WS_WIN */
 
     /* Populating interface list */
@@ -516,8 +518,12 @@
                                        QTreeWidgetItem *)
 {
+# if defined (Q_WS_WIN)
     VBoxNIListItem *item = aCurrent &&
         aCurrent->type() == VBoxNIListItem::typeId ?
         static_cast<VBoxNIListItem*> (aCurrent) : 0;
     mDelAction->setEnabled (item && !item->isWrong());
+# else
+    NOREF (aCurrent);
+# endif
 
     emit currentInterfaceChanged (mList->currentItem() ?
@@ -527,4 +533,5 @@
 void VBoxNIList::addHostInterface()
 {
+# if defined (Q_WS_WIN)
     /* Allow the started helper process to make itself the foreground window */
     AllowSetForegroundWindow (ASFW_ANY);
@@ -569,4 +576,5 @@
     /* Allow the started helper process to make itself the foreground window */
     AllowSetForegroundWindow (ASFW_ANY);
+# endif /* Q_WS_WIN */
 }
 
@@ -575,4 +583,5 @@
     Assert (mList->currentItem());
 
+# if defined (Q_WS_WIN)
     /* Allow the started helper process to make itself the foreground window */
     AllowSetForegroundWindow (ASFW_ANY);
@@ -618,4 +627,5 @@
 
     emit listChanged();
+# endif /* Q_WS_WIN */
 }
 
@@ -626,4 +636,5 @@
     mList->setWhatsThis (tr ("Lists all available host interfaces."));
 
+# if defined (Q_WS_WIN)
     mAddAction->setText (tr ("A&dd New Host Interface"));
     mDelAction->setText (tr ("&Remove Selected Host Interface"));
@@ -634,4 +645,5 @@
     mDelAction->setToolTip (mDelAction->text().remove ('&') +
         QString (" (%1)").arg (mDelAction->shortcut().toString()));
+# endif /* Q_WS_WIN */
 }
 
@@ -661,5 +673,5 @@
     onCurrentItemChanged (mList->currentItem());
 }
-#endif
+#endif /* Q_WS_WIN || Q_OS_MAC */
 
 
@@ -678,5 +690,5 @@
     populateNetworksList();
 
-#ifdef Q_WS_WIN
+#if defined (Q_WS_WIN) || defined (Q_OS_MAC)
     /* Creating Interfaces List */
     mNIList = new VBoxNIList (this);
@@ -725,5 +737,5 @@
     }
 
-#ifdef Q_WS_WIN
+#if defined (Q_WS_WIN) || defined (Q_OS_MAC)
     setTabOrder (lastFocusWidget, mNIList->focusProxy());
     connect (mTwAdapters, SIGNAL (currentChanged (int)),
@@ -752,5 +764,5 @@
 {
     mValidator = aVal;
-#ifdef Q_WS_WIN
+#if defined (Q_WS_WIN) || defined (Q_OS_MAC)
     connect (mNIList, SIGNAL (listChanged()), mValidator, SLOT (revalidate()));
 #endif
@@ -771,5 +783,5 @@
             vboxGlobal().toNetworkAttachmentType (page->mCbNAType->currentText());
 
-#ifdef Q_WS_WIN
+#if defined (Q_WS_WIN) || defined (Q_OS_MAC)
         if (type == KNetworkAttachmentType_HostInterface &&
             page->interfaceName().isNull())
@@ -840,5 +852,5 @@
 }
 
-#ifdef Q_WS_WIN
+#if defined (Q_WS_WIN) || defined (Q_OS_MAC)
 void VBoxVMSettingsNetworkPage::onCurrentPageChanged (int aIndex)
 {